﻿Imports System.Net.Sockets
Public Class Form1
    Public Mydelegate As [Delegate]
    Delegate Sub AddListItem()

    Public Sub AddListItemMethod()
        StatusDisplay()
    End Sub


    Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
        Mydelegate = New AddListItem(AddressOf AddListItemMethod)
    End Sub

    Private Sub server_DoWork(sender As System.Object, e As System.ComponentModel.DoWorkEventArgs) Handles server.DoWork
        Listener.Start()
        While True
            Try
                Dim client As New MainServer(Listener.AcceptTcpClient, Me)
            Catch ex As Exception
                Exit Sub
            End Try
        End While
    End Sub

    Private Sub btnStart_Click(sender As System.Object, e As System.EventArgs) Handles btnStart.Click
        If Not server.IsBusy Then startserver()
    End Sub

    Private Sub startserver()
        If Me.InvokeRequired Then
            Me.Invoke(New MethodInvoker(AddressOf startserver))
        Else
            server.RunWorkerAsync()
            Stats.AppendText("Server Starting..." & vbNewLine)
            Stats.ScrollToCaret()
        End If
    End Sub

    Public Sub StatusDisplay()
        If Me.InvokeRequired Then
            Me.Invoke(New MethodInvoker(AddressOf StatusDisplay))
        Else
            Stats.AppendText(StatusMsg & vbNewLine)
            Stats.ScrollToCaret()
        End If
    End Sub
    Private Sub SecCount_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SecCount.Tick '(Broken) timer designed to remove an IP after 15 seconds
        Dim index As Integer = -1
        If Not MainServer.ClientsAllIPs Is Nothing Then
            For Each ConnectedIP In MainServer.ClientsAllIPsCount
                index += 1
                ConnectedIP = (Val(ConnectedIP) - 1).ToString()
                If Val(ConnectedIP) = -1 Then
                    Stats.AppendText("Client Removed: " & MainServer.ClientsAllIPs.Item(index) & vbNewLine)
                    Stats.ScrollToCaret()
                    MainServer.ClientsAllIPs.RemoveAt(index)
                    MainServer.ClientsAllIPsCount.RemoveAt(index)
                End If
            Next
        End If
    End Sub
End Class
Public Class MainServer
    '---contains a list of all the clients

    '---information about the client
    Private _client As TcpClient
    Private _clientIP As String
    Private _ClientTrueIP As String
    Private _ClientUser As String
    Public Shared AllClients As New Hashtable
    Public Shared ClientsAllIPs As New System.Collections.Specialized.StringCollection
    Public Shared ClientsAllIPsCount As New System.Collections.Specialized.StringCollection

    '---used for sending/receiving data
    Private data() As Byte

    '---is the nick name being sent?
    Private myFormControl1 As Form1
    Private ReceiveNick As Boolean = True
    Public Sub New(ByVal client As TcpClient, myForm As Form1)
        myFormControl1 = myForm
        _client = client

        '---get the client IP address
        _clientIP = client.Client.RemoteEndPoint.ToString

        '---add the current client to the hash table
        AllClients.Add(_clientIP, Me)
        '---start reading data from the client in a separate thread
        ReDim data(_client.ReceiveBufferSize)
        _client.GetStream.BeginRead(data, 0, CInt(_client.ReceiveBufferSize), AddressOf ReceiveMessage, Nothing)
    End Sub

    Public Sub SendMessage(ByVal message As String)
        Try
            '---send the text
            Dim ns As System.Net.Sockets.NetworkStream
            SyncLock _client.GetStream
                ns = _client.GetStream
            End SyncLock
            Dim bytesToSend As Byte() = _
                System.Text.Encoding.ASCII.GetBytes(message)
            ns.Write(bytesToSend, 0, bytesToSend.Length)
            ns.Flush()
        Catch ex As Exception

        End Try
    End Sub

    Public Sub ReceiveMessage(ByVal ar As IAsyncResult)
        '---read from client---
        If AllClients.Contains(_clientIP) = False Then
            _client.Close()
            Exit Sub
        End If
        Dim bytesRead As Integer
        Try
            SyncLock _client.GetStream
                bytesRead = _client.GetStream.EndRead(ar)
            End SyncLock
            '---client has disconnected
            If bytesRead < 1 Then
                AllClients.Remove(_clientIP)
                _client.Close()
                Exit Sub
            Else
                '---get the message sent
                Dim messageReceived As String = _
                    System.Text.Encoding.ASCII. _
                    GetString(data, 0, bytesRead)
                '---client is sending its nickname
                If ReceiveNick Then
                    Dim GetIP() As String = Split(_clientIP, ":")
                    If ClientsAllIPs Is Nothing Then
                        ClientsAllIPs = New Specialized.StringCollection
                    End If
                    StatusMsg = "Client Connected: " & _ClientTrueIP
                    myFormControl1.Invoke(myFormControl1.Mydelegate)
                    _ClientTrueIP = GetIP(0).Trim
                    Dim IPExist As Boolean = False
                    For Each IP In ClientsAllIPs
                        If IP.Trim = _ClientTrueIP.Trim Then
                            IPExist = True
                            Exit For
                        End If
                    Next
                    If IPExist = False Then
                        ClientsAllIPs.Add(_ClientTrueIP)
                        ClientsAllIPsCount.Add("15")
                    End If
                    Dim Break As String = "|"
                    Dim ListOfIP As String = ""
                    For Each IPAgain In ClientsAllIPs
                        ListOfIP += IPAgain & Break
                    Next
                    Broadcast(ListOfIP)
                    ReceiveNick = False
                Else
                    '---broadcast the message to everyone
                    Broadcast(messageReceived)
                End If
                End If
            '---continue reading from client
            SyncLock _client.GetStream
                _client.GetStream.BeginRead(data, 0, _
                   CInt(_client.ReceiveBufferSize), _
                   AddressOf ReceiveMessage, Nothing)
            End SyncLock
        Catch ex As Exception
            AllClients.Remove(_clientIP)
            _client.Close()
        End Try
    End Sub


    Public Sub Broadcast(ByVal message As String)
        '---log it locally
        StatusMsg = message
        myFormControl1.Invoke(myFormControl1.Mydelegate)
        Dim c As DictionaryEntry
        For Each c In AllClients
            '---broadcast message to all users
            CType(c.Value, MainServer).SendMessage(message & vbCrLf)
        Next
    End Sub
End Class
